import ecs100.*;

/** Controls two CartoonCharacters with Buttons, Slider, and TextField
 */
public class PuppetMaster {
    // Fields

    private CartoonCharacter cf1 = new CartoonCharacter(100, 100, "blueguy");
    private CartoonCharacter cf2 = new CartoonCharacter(500, 100, "greenguy");
    private CartoonCharacter selectedCC = cf1;
    private double moveDistance = 20;

    /** set up the GUI     */
    public void setupGUI(){

        UI.addButton("Jim", this::doJim);
        UI.addButton("Jan", this::doJan);
        UI.addButton("Smile", this::doSmile);
        UI.addButton("Frown", this::doFrown);
        UI.addButton("Left", this::doLeft);
        UI.addButton("Right", this::doRight);
        UI.addButton("Walk", this::doWalk);
        UI.addSlider("Distance", 0, 100, this.moveDistance, this::doDist);
        UI.addTextField("Speak", this::doSpeak);
        UI.addButton("Quit", UI::quit);

    }

    public void doJim()  {
        this.selectedCC = cf1;
    }

    public void doJan()  {
        this.selectedCC = cf2;
    }

    public void doSmile(){
        this.selectedCC.smile();
    }

    public void doFrown(){
        this.selectedCC.frown();
    }

    public void doLeft() {
        this.selectedCC.lookLeft();
    }

    public void doRight(){
        this.selectedCC.lookRight();
    }

    public void doWalk() {
        this.selectedCC.walk(this.moveDistance);
    }

    public void doDist(double value){
        this.moveDistance = value;
    }

    public void doSpeak(String value){
        this.selectedCC.speak(value);
    }

    // Main
    public static void main(String[] arguments){
        new PuppetMaster().setupGUI();
    }	

}
